import { Matrix3, Matrix4, Texture, Vector2, Vector3, Vector4 } from 'three';
import { Compiler } from './compiler';
import { BooleanNode, FloatNode, Mat2Node, Mat3Node, Mat4Node, Sampler2DNode, Vec2Node, Vec3Node, Vec4Node } from './types';
export declare class UniformBoolNode extends BooleanNode {
    private readonly name;
    private readonly value;
    constructor(name: string, value?: boolean);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformFloatNode extends FloatNode {
    private readonly name;
    private readonly value;
    constructor(name: string, value?: number);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformVec2Node extends Vec2Node {
    private readonly name;
    private readonly value?;
    constructor(name: string, value?: Vector2 | undefined);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformVec3Node extends Vec3Node {
    private readonly name;
    private readonly value?;
    constructor(name: string, value?: Vector3 | undefined);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformVec4Node extends Vec4Node {
    private readonly name;
    private readonly value?;
    constructor(name: string, value?: Vector4 | undefined);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformMat2Node extends Mat2Node {
    private readonly name;
    private readonly value?;
    constructor(name: string, value?: any);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformMat3Node extends Mat3Node {
    private readonly name;
    private readonly value?;
    constructor(name: string, value?: Matrix3 | undefined);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformMat4Node extends Mat4Node {
    private readonly name;
    private readonly value?;
    constructor(name: string, value?: Matrix4 | undefined);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
export declare class UniformSampler2d extends Sampler2DNode {
    private readonly name;
    private readonly value?;
    constructor(name: string | null, value?: Texture | undefined);
    compile(c: Compiler): import("./compiler").CompileResult<string>;
}
