import { IntNode } from './types';
export declare class Compiler {
    private readonly cachedOuts;
    private readonly scopedCachedOuts;
    readonly pars: string[];
    readonly chunks: string[];
    readonly uniforms: {
        [key: string]: {
            value: unknown;
        };
    };
    private inScope;
    private variableNumber;
    variable(): number;
    startScope(...copiedNodes: ShaderNode[]): void;
    stopScope(): void;
    get<T>(node: ShaderNode<T>): T;
    private cachedUniforms;
    defineUniform(type: string, name: string | null, value?: unknown): CompileResult<string>;
    private registerStructDefinition;
    getPars(): string;
    getMain(): string;
    render(): string;
}
export declare class FragmentCompiler extends Compiler {
    private readonly vertexCompiler;
    constructor(vertexCompiler: Compiler);
    defineVarying<T>(type: string, node: ShaderNode<T>, arrayLimit?: number | IntNode | null): CompileResult<string>;
    getVarying<T>(type: string, node: ShaderNode<T>): string;
}
export declare type CompileResult<T> = {
    readonly chunk?: string;
    readonly out: T;
    readonly pars?: string;
};
export declare type ShaderNode<T = string> = {
    compile(c: Compiler): CompileResult<T>;
};
